routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
#### TEST ####

Route::group(['prefix' => '/test'], function () {
  Route::get('/getCities', 'TestController@getCities')->name('test.cities');
});


#### SITE ####


#### PAYMENT ####

Route::group(['prefix' => 'payments'], function () {
  Route::group(['prefix' => 'checkout'], function () {
    Route::get('liqpay', 'PaymentController@payViaLiqPay')->name('pay.checkout.liqpay');
  });

  Route::group(['prefix' => 'callback'], function () {
    Route::get('liqpay', 'PaymentController@callbackTransactionViaLiqPay')->name('pay.callback.liqpay');
  });

  Route::group(['prefix' => 'listener'], function () {
    Route::match(['GET', 'POST'], 'liqpay', 'PaymentController@listenerTransactionViaLiqPay')->name('pay.listener.liqpay');
  });
});

#### PAYMENT ####


Route::get('/', 'MainController@index')->name('site.home');

#### PRODUCTS ####

Route::group(['prefix' => 'products'], function () {
  Route::get('/', 'ProductController@index')->name('site.products.index');
  Route::get('/{product:alias}', 'ProductController@show')->name('site.products.show');
  Route::post('/order', 'ProductController@order')->name('site.products.order');
});

#### PRODUCTS ####

#### CART ####

Route::group(['prefix' => 'cart'], function () {
  #### PAGES ####

  Route::get('/', 'CartController@index')->name('cart.index');
  Route::get('/confirm', 'CartController@confirm')->name('cart.confirm');

  #### PAGES ####

  #### ITEMS ####

  Route::put('/edit-item/{orderProduct}', 'CartController@editItem')->name('cart.editItem');
  Route::delete('/delete-item/{orderProduct}', 'CartController@deleteItem')->name('cart.deleteItem');

  #### ITEMS ####

  Route::post('/checkout', 'CartController@checkout')->name('cart.checkout');

  Route::get('/success', 'CartController@success')
    ->name('cart.success')
    ->middleware(\App\Http\Middleware\FlashSuccessOrderMiddleware::class);
});

#### CART ####

#### STATIC ####

Route::get('/about', 'StaticController@about')->name('about');
Route::get('/contacts', 'StaticController@contacts')->name('contacts');
Route::get('/faq', 'StaticController@faq')->name('faq');
Route::get('/delivery', 'StaticController@delivery')->name('delivery');
Route::get('/warranty', 'StaticController@warranty')->name('warranty');
Route::get('/back-product', 'StaticController@backProduct')->name('backProduct');

#### STATIC ####

#### SITE ####


#### ADMIN PANEL ####

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');


Route::get('/admin', 'HomeController@index')->name('home');

Route::group(['prefix' => '/admin', 'middleware' => 'auth', 'namespace' => 'Admin'], function () {

  #### CATEGORY ####

  Route::resource('categories', 'CategoryController');
  Route::group(['prefix' => '/categories'], function () {
    Route::post('/reorder', 'CategoryController@reorder');
  });

  #### CATEGORY ####

  #### SUBCATEGORY ####

  Route::resource('sub-categories', 'SubCategoryController');
  Route::group(['prefix' => '/sub-categories'], function () {
    Route::post('/reorder', 'SubCategoryController@reorder');
  });

  #### SUBCATEGORY ####

  #### ATTRIBUTES ####

  Route::resource('attributes', 'AttributeController');
  Route::group(['prefix' => '/attributes'], function () {
    Route::post('/reorder', 'AttributeController@reorder');
  });

  #### ATTRIBUTES ####

  #### ATTRIBUTE OPTIONS ####

  Route::resource('attribute-options', 'AttributeOptionController');
  Route::group(['prefix' => '/attribute-options'], function () {
    Route::post('/reorder', 'AttributeOptionController@reorder');
  });

  #### ATTRIBUTE OPTIONS ####

  #### PRODUCTS ####

  Route::resource('products', 'ProductController');
  Route::group(['prefix' => '/products'], function () {
    Route::post('/reorder', 'ProductController@reorder');
    Route::post('/reorder-picture', 'ProductController@reorderPictures');
  });

  #### PRODUCTS ####

  #### ORDERS ####

  Route::group(['prefix' => 'orders'], function () {
    Route::get('/', 'OrderController@index')->name('orders.index');
    Route::post('/{order}/accept', 'OrderController@accept')->name('order.accept');
    Route::post('/{order}/confirmed', 'OrderController@confirmed')->name('order.confirmed');
    Route::post('/{order}/canceled', 'OrderController@canceled')->name('order.canceled');
  });

  #### ORDERS ####

  #### SEO ####

  Route::resource('seo', 'SeoController')->except([
    'show'
  ]);

  #### SEO ####

});

#### ADMIN PANEL ####

app/Models/Attribute.php
<?php

namespace App\Models;

use App\Models\Helpers\CriteriaActions;
use App\Models\Helpers\ReorderRecord;
use App\Models\Mixins\AttributeMixin;
use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Database\Eloquent\Collection;
use \Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Support\Carbon;

/**
 * Class Attribute
 * @package App\Models
 *
 * @property integer $id
 * @property string $alias
 * @property string $title
 * @property integer $display_order
 * @property boolean $is_color
 * @property Carbon $created_at
 * @property Carbon $updated_at
 * @property Carbon $deleted_at
 *
 * @property AttributeOption[]|Collection $attributeOptions
 */
class Attribute extends Model {
  use SoftDeletes, CriteriaActions, ReorderRecord, Sluggable, AttributeMixin;

  const IS_COLOR = 1;

  /**
   * @var string
   */
  protected $table = 'attributes';

  /**
   * The attributes that are mass assignable.
   *
   * @var array
   */
  protected $fillable = [
    'alias',
    'title',
    'display_order',
    'is_color',
  ];

  /**
   * The attribute provides a convenient method of converting attributes to common data types
   *
   * @var array
   */
  protected $casts = [
    'alias' => 'string',
    'title' => 'string',
    'display_order' => 'integer',
    'is_color' => 'boolean',
  ];

  /**
   * Generate an alias
   *
   * @return array|\string[][]
   */
  public function sluggable(): array {
    return [
      'alias' => [
        'source' => 'title',
      ],
    ];
  }

  /**
   * Get product attributes for the attribute
   *
   * @return \Illuminate\Database\Eloquent\Relations\HasMany
   */
  public function attributeOptions() {
    return $this->hasMany(AttributeOption::class, 'attribute_id', 'id');
  }
}

app/Http/Controllers/Admin/AttributeController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AttributeRequest;
use App\Http\Requests\ReorderRecordFormRequest;
use App\Models\Attribute;
use App\Services\Actions\AttributeServiceAction;
use Illuminate\Http\RedirectResponse;
use Illuminate\View\View;

class AttributeController extends Controller {
  /**
   * @var AttributeServiceAction
   */
  protected $service;

  /**
   * AttributeController constructor.
   *
   * @param AttributeServiceAction $service
   */
  public function __construct(AttributeServiceAction $service) {
    $this->service = $service;
  }

  /**
   * @return View
   */
  public function index(): View {
    $attributes = Attribute::query()
      ->orderBy('display_order', 'asc')
      ->get();

    return view('admin.attributes.index', [
      'attributes' => $attributes,
    ]);
  }

  /**
   * @return View
   */
  public function create(): View {
    return view('admin.attributes.edit', [
      'attribute' => new Attribute(),
    ]);
  }

  /**
   * @param AttributeRequest $request
   * @return RedirectResponse
   */
  public function store(AttributeRequest $request) {
    $this->service->createAttribute($request->createDto());
    return redirect()
      ->route('attributes.index')
      ->with(['message' => 'Атрибут сохранен.', 'class' => 'success']);
  }

  /**
   * @param Attribute $attribute
   * @return View
   */
  public function edit(Attribute $attribute): View {
    return view('admin.attributes.edit', [
      'attribute' => $attribute,
    ]);
  }

  /**
   * Update the specified resource in storage.
   *
   * @param Attribute $attribute
   * @param AttributeRequest $request
   * @return RedirectResponse
   */
  public function update(Attribute $attribute, AttributeRequest $request) {
    $this->service->updateAttribute($attribute, $request->createDto());

    return redirect()->route('attributes.index')->with([
      'message' => 'Атрибут изменен.',
      'class' => 'success'
    ]);
  }

  /**
   * @param Attribute $attribute
   * @return RedirectResponse
   * @throws \Exception
   *
   */
  public function destroy(Attribute $attribute) {
    $attribute->delete();
    return redirect()->route('attributes.index')->with([
      'class' => 'success',
      'message' => 'Атрибут успешно удален.',
    ]);
  }

  /**
   * @param ReorderRecordFormRequest $request
   * @return \Illuminate\Http\JsonResponse
   */
  public function reorder(ReorderRecordFormRequest $request) {
    if ($this->service->reorder((int)$request->json('currentId'), (int)$request->json('desiredId'), Attribute::class)) {
      return response()->json(['status' => 'reorder']);
    }

    return response()->json(['error' => 'Атрибут не найден'], 404);
  }
}

resources/views/admin/attributes/edit.blade.php
<?php
/* @var array $errors */
/* @var \App\Models\Attribute $attribute */
?>

@extends('admin.layouts.app')

@section('content')

  <div class="container">
    <br>
    <div class="row">
      <div class="col-12">
        <a href="{{ route('attributes.index') }}" class="btn btn-sm btn-secondary">Назад</a>
      </div>
    </div>
    <div class="row">
      <div class="col-12">
        <form method="POST"
              @if($attribute->exists)
              action="{{ route('attributes.update', ['attribute' => $attribute]) }}"
              @else
              action="{{ route('attributes.store') }}"
              @endif
              enctype='multipart/form-data'>
          @csrf
          @if($attribute->exists)
            @method('PUT')
          @endif
          @component('admin.includes.formGroup', ['errors' => $errors, 'property' => 'title', 'label' => 'Атрибут'])
            <input type="text" required class="form-control" name="title" id="inputTitle"
                   value="{{ old('title') ? old('title') : $attribute->title }}">
          @endcomponent
          <br>
          <div class="form-group col-sm-12">
            <br>
            <label class="css-control css-control-sm css-control-primary css-switch">
              <input type="checkbox" name="is_color" value="1" class="css-control-input"
                     @if(old('is_color') == $attribute::IS_COLOR || (!$attribute->isNew() && $attribute->isColor())) checked @endif>
              <span class="css-control-indicator"></span> Цвет
            </label>
          </div>

          <div class="form-group row">
            <div class="col-sm-10">
              <button type="submit" class="btn btn-sm btn-success">Сохранить</button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
@endsection

resources/views/admin/attributes/index.blade.php
<?php
/* @var \App\Models\Attribute[] $attributes */
?>

@extends('admin.layouts.app')

@section('content')
  <div class="container">
    <div class="row">
      <div class="col-12">
        <h2>Атрибуты</h2>
      </div>
    </div>
    <div class="buttons">
      <div class="button-group form-group">
        <a href="{{ route('attributes.create') }}">
          <button type="button" class="btn btn-sm btn-success"><i class="fa fa-pencil" aria-hidden="true"></i> Создать
          </button>
        </a>
      </div>
    </div>
    <br>
    <div class="row">
      <div class="col-12">
        <table id="sortable" class="table table-striped">
          <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Название</th>
            <th scope="col">alias</th>
            <th scope="col"></th>
            <th scope="col"></th>
          </tr>
          </thead>
          <tbody>

          @foreach($attributes as $i => $attribute)
            <tr data-index="{{ $i }}" data-id="{{ $attribute->id }}" data-entity="{{ $attribute->getTable() }}">
              <th scope="row">{{ $loop->index + 1 }}</th>
              <td>{{ $attribute->title }}</td>
              <td>{{ $attribute->alias }}</td>
              <td>
                <a href="{{ route('attributes.edit', ['attribute' => $attribute])}}"
                   data-toggle="tooltip" title="Редактировать">
                  <i class="fa fa-pencil-square-o" aria-hidden="true"></i>
                </a>
              </td>
              <td>
                <form action="{{route('attributes.destroy',['attribute' => $attribute])}}" method="POST">
                  @method('DELETE')
                  @csrf
                  <button data-toggle="tooltip" onclick="return confirm('Вы действительно хотите удалить?')" class="fa fa-trash" aria-hidden="true"></button>
                </form>
              </td>
            </tr>
          @endforeach

          </tbody>
        </table>

      </div>
    </div>
  </div>
@endsection

@section('scripts')
  <script type="text/javascript" src="{{ \EscapeWork\Assets\Facades\Asset::v('js/sortable.js') }}"></script>
@endsection